/*
 * zavlazovaci_system_2.c
 *
 * Created: 10/30/2015 10:26:05 AM
 *  Author: otichy
 */ 


#define F_CPU 1000000
#include <util/delay.h>
#include <avr/interrupt.h>
#include "lcd.h"
#include <avr/io.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include "rtc2.h"

char Procenta[4];//ctyrmistne cislo-deklarace promennych do kterych se ulozi vysledek prevodu
int vysledek=0;
int PromennaMenu=0;//ukladani cisla do case Menu

int PromennaMikrozavlaha=1;
int MikrozavlahaStart=0;//ukladani casu zalevani
int MikrozavlahaStop=0;//ukladani casu zalevani
char PoleMikrozavlahaStart[3];
char PoleMikrozavlahaStop[3];

int PromennaZavlaha=0;
int ventil1=0;
int ventil2=0;
int ventil3=0;
char PoleVentil1[4];
char PoleVentil2[4];
char PoleVentil3[4];
bool sekvence;
int hodiny=19;
int hodiny_sekv=0;
int minuty=0;
int minuty_sekv=0;
char PoleHodiny[2];
char PoleMinuty[2];

int sonda=(-1);

char PoleOdpocet[4];




char buf[64] = {0};

ISR(ADC_vect)
{
	
	ADCSRA |=1<<ADSC;//start dalsiho prevodu a/d
}


int Menu(PromennaMenu,PromennaMikrozavlaha,PromennaZavlaha,vysledek)
{

	switch (PromennaMenu)
	{
		case 0: //Uvodni obrazovka
		{
			lcd_gotoxy(0,0);
			lcd_clrscr();
			lcd_puts("Vlhkost:");
			lcd_puts(Procenta);
			lcd_puts("%");
			_delay_ms(150);
			return PromennaMenu;
			break;
		}
		case 1: // Mikrozvlaha
		{
			lcd_clrscr();
			lcd_gotoxy(0,0);
			lcd_puts("Mikrozavlaha");
			_delay_ms(10);
			
			switch (PromennaMikrozavlaha)// moznosti nastaveni pro Mikrozavlahu
			{
				case 2://Start zalevani
				{
					lcd_gotoxy(0,1);
					lcd_puts("Start: ");
					_delay_ms(10);
					if ((PINB & (1 << PB2))==0)
					{
						MikrozavlahaStart--;
						_delay_ms(100);
						if (MikrozavlahaStart<0)
						{
							MikrozavlahaStart=0;
						}
					}
					if ((PINB & (1 << PB3))==0)
					{
						MikrozavlahaStart++;
						_delay_ms(10);
						if (MikrozavlahaStart>100)
						{
							MikrozavlahaStart=100;
						}
						
					}
					if (MikrozavlahaStart>MikrozavlahaStop)// osetren aby nedochazele k nastaveni vetsi hodnoty start ne hodnoty stop
					{
						MikrozavlahaStart=MikrozavlahaStop-1;
					}
					itoa(MikrozavlahaStart,PoleMikrozavlahaStart,10);
					lcd_puts(PoleMikrozavlahaStart);
					lcd_puts("%");
					_delay_ms(100);
					return PromennaMikrozavlaha;
					break;
				}
				
				case 1://Stop zalevani
				{
					lcd_gotoxy(0,1);
					lcd_puts("          ");
					lcd_gotoxy(0,1);
					lcd_puts("Stop: ");
					if ((PINB & (1 << PB2))==0)
					{
						MikrozavlahaStop--;
						_delay_ms(100);
						if (MikrozavlahaStop<0)
						{
							MikrozavlahaStop=0;
						}
						
					}
					if ((PINB & (1 << PB3))==0)
					{
						MikrozavlahaStop++;
						_delay_ms(10);
						if (MikrozavlahaStop>100)
						{
							MikrozavlahaStop=100;
						}
					}
					if (MikrozavlahaStop<MikrozavlahaStart)// osetren aby nedochazelo k nastaveni mensi hodnoty stop, ne je hodnota start
					{
						MikrozavlahaStop=MikrozavlahaStart+1;
					}
					itoa(MikrozavlahaStop,PoleMikrozavlahaStop,10);
					lcd_puts(PoleMikrozavlahaStop);
					lcd_puts("%");
					_delay_ms(110);
					return PromennaMikrozavlaha;
					break;
					
				}
				
				
			}
						
			return PromennaMenu;
			break;
			
		}
		
		case 2: //Zavlaha
		{
			lcd_clrscr();
			lcd_gotoxy(0,0);
			lcd_puts("Zavlaha");
			_delay_ms(10);
			switch (PromennaZavlaha)
			{
				case 0://Ventil1 - delka oteven
				{
					lcd_gotoxy(0,1);
					lcd_gotoxy(0,1);
					lcd_puts("Ventil1[m] ");
					_delay_ms(10);
					if ((PINB & (1 << PB2))==0)
					{
						ventil1=ventil1-1;
						_delay_ms(10);
						if (ventil1<0)
						{
							ventil1=0;
						}
					}
					
					if ((PINB & (1 << PB3))==0)
					{
						ventil1=ventil1+1;
						_delay_ms(10);
						if (ventil1>20)
						{
							ventil1=20;
						}
												
					}
					itoa(ventil1,PoleVentil1,10);
					lcd_puts(PoleVentil1);
					lcd_puts("min");
					_delay_ms(110);
					return PromennaZavlaha;
					
				}
				case 1://Ventil2 - delka oteven
				{
					lcd_gotoxy(0,1);
					lcd_puts("          ");
					lcd_gotoxy(0,1);
					lcd_puts("Ventil2[m] ");
					_delay_ms(10);
					if ((PINB & (1 << PB2))==0)
					{
						ventil2=ventil2-1;
						_delay_ms(10);
						if (ventil2<0)
						{
							ventil2=0;
						}
					}
					
					if ((PINB & (1 << PB3))==0)
					{
						ventil2=ventil2+1;
						_delay_ms(10);
						if (ventil2>20)
						{
							ventil2=20;
						}
						
					}
					itoa(ventil2,PoleVentil2,10);
					lcd_puts(PoleVentil2);
					lcd_puts("min");
					_delay_ms(110);
					return PromennaZavlaha;
					break;
				}
				case 2://Ventil3 - delka oteven
				{
					lcd_gotoxy(0,1);
					lcd_puts("          ");
					lcd_gotoxy(0,1);
					lcd_puts("Ventil3[m] ");
					_delay_ms(10);
					if ((PINB & (1 << PB2))==0)
					{
						ventil3=ventil3-1;
						_delay_ms(10);
						if (ventil3<0)
						{
							ventil3=0;
						}
					}
					
					if ((PINB & (1 << PB3))==0)
					{
						ventil3=ventil3+1;
						_delay_ms(10);
						if (ventil3>20)
						{
							ventil3=20;
						}
						
					}
					itoa(ventil3,PoleVentil3,10);
					lcd_puts(PoleVentil3);
					lcd_puts("min");
					_delay_ms(110);
					return PromennaZavlaha;
					break;
				}
				case 3://Nastaven jestli zavlazovat sekvencne a nebo ne
				{
					lcd_gotoxy(0,1);
					lcd_puts("          ");
					lcd_gotoxy(0,1);
					lcd_puts("Sekvence:  ");
					_delay_ms(10);
					if ((PINB & (1 << PB2))==0)
					{
						sekvence=true;
						_delay_ms(10);
						
						
					}
					if ((PINB & (1 << PB3))==0)
					{
						sekvence=false;
						_delay_ms(10);
						
						
					}
					if (sekvence==true)
					{
						lcd_gotoxy(0,1);
						lcd_puts("Sekvence:  Ano");
						_delay_ms(110);
					}
					else if (sekvence==false)
					
					{
						lcd_gotoxy(0,1);
						lcd_puts("Sekvence: Ne");
						_delay_ms(110);
					}
					return PromennaZavlaha;
					break;
				}
				case 4://nastaven asu
				{
					lcd_gotoxy(0,1);
					lcd_puts("Zalevat v ");
					 if ((PINB & (1 << PB2))==0)
					 {
						 hodiny+=1;
						 						 
						 if (hodiny>23)
						 {
							 hodiny=23;
						 }
						 
					 }
					 
					 if ((PINB & (1 << PB3))==0)
					 {
						 hodiny-=1;
						 if (hodiny<0)
						 {
							 hodiny=0;
						 }
						 
						 
					 }	
					 itoa(hodiny,PoleHodiny,10);
					 lcd_gotoxy(10,1);
					 lcd_puts(PoleHodiny);
					 lcd_puts(":");
					 lcd_puts("00");	
					_delay_ms(110);
					break;
				}
			}
			return PromennaMenu;
			break;
		}
		case 3://----------------------NASTAVENI CASU---------------------------//
		{
			
			lcd_clrscr();
			lcd_gotoxy(0,0);
			lcd_puts("Nastaveni casu:");
			
			 if ((PINB & (1 << PB2))==0)
			 {
				RTC2_VALUE->hours+=1;
				
				
				 if (RTC2_VALUE->hours>23)
				 {
					RTC2_VALUE->hours=0;
				 }
				 rtc2_preset(RTC2_VALUE);
			 }
			 
			 if ((PINB & (1 << PB3))==0)
			 {
				 RTC2_VALUE->minutes+=1;
				  if (RTC2_VALUE->minutes>59)
				  {
					  RTC2_VALUE->minutes=0;
				  }
				  rtc2_preset(RTC2_VALUE);
				 
			 }
			 sprintf(buf, "%02i:%02i:%02i ",RTC2_VALUE->hours, RTC2_VALUE->minutes, RTC2_VALUE->seconds);
			
			lcd_gotoxy(0,1);
			lcd_puts(buf);
			_delay_ms(110);
			rtc2_update(RTC2_VALUE);	
			return PromennaMenu;
		}
		
	}
}


int main(void)
{
	//konfigurace a/d
	ADCSRA |=1<<ADIE;//Povolen peruen v A/d
	
	ADCSRA |=1<<ADPS2;//zapnut preddelicky definovan internm osc
	ADMUX |=1<<ADLAR; //zarovnani do leva
	ADMUX |=1<<REFS0;//urceni referencniho napeti a/d
	ADCSRA |= 1<<ADEN; //zapnut adc prislusenstv
	
	
	sei();//Povolen globlnho peruen
	

	rtc2_init();
	rtc2_preset(RTC2_VALUE);
	
	
	RTC2_VALUE->format=RTC2_FORMAT_24;
	ADCSRA |=1<<ADSC;//start prvnho prevodu
	
	DDRB=0b00010001;//konfigurace registr pro tlacitka  + pb0 vystupn pro rele1(dioda)
	PORTB=0b11101110; //nastaveni pull up rezistoru
	DDRD |=(1<<PIND7)|(1<<PIND6)|(1<<PIND5);//vystupni  piny PD7,6,5 pro rele
	
	lcd_init(LCD_DISP_ON);
	lcd_clrscr();
	
		
    while(1)
    {
        vysledek=1.5152*ADCH - 136.36;//prepocet vysledku A/D prevodu na procenta
        if (vysledek<0)
        {
	        vysledek=0;
        }
        if (vysledek>100)
        {
	        vysledek=100;
        }
        itoa(vysledek,Procenta,10);//prevod vysledku na string
       
       		
			if ((PINB & (1<<PB1))==0)//kdyz se stistkne tlacitko PORTB1 - MENU
			{
				_delay_ms(100);
				PromennaMenu++;
				if (PromennaMenu>3)
				{
					PromennaMenu=0;
				}
			
			}
			if (PINB & (1<<PB4)&& (PromennaMenu==1))// jestlie se stiskne PB4 a nachzm se v mikrozavlaze, nav se hodnota PromennaMikrozavlaha
			{
				_delay_ms(100);
				PromennaMikrozavlaha++;
				if (PromennaMikrozavlaha>2)
				{
					PromennaMikrozavlaha=1;
				}
			}
			
			
			
			if (PINB & (1<<PB4)&& (PromennaMenu==2))// jestlie se stiskne PB4 a nachzm se v ZAVLAZE, nav se hodnota PromennaZavlaha
			{
				_delay_ms(100);
				PromennaZavlaha++;
				if (PromennaZavlaha>4)
				{
					PromennaZavlaha=0;
				}
			}
			Menu(PromennaMenu,PromennaMikrozavlaha,PromennaZavlaha,vysledek);//Metoda menu
			
			//--------------\Mikrozavlaha------------------//
			if (vysledek<=MikrozavlahaStart)//spousteni ventilu-Start
			{
				PORTB |=(1<<PB0);
			}
			if (vysledek>=MikrozavlahaStop)
			{
				PORTB &=~(1<<PB0);
			}
			
			if (ventil1==0 && ventil2==0 && ventil3 ==0)
			{
				PORTB &=~(1<<PD7)|(1<<PD6)|(1<<PD5);
			}
			//----------------------ZAVLAHA bez sekvence---------------//
			else if (sekvence==false)
			{
				
				rtc2_update(RTC2_VALUE);
				if (hodiny==RTC2_VALUE->hours && minuty== RTC2_VALUE->minutes)
				{
					PORTD |=(1<<PD7)|(1<<PD6)|(1<<PD5);
				}
				if ((RTC2_VALUE->minutes-ventil1)>=minuty )
				{
					PORTD&=~(1<<PD7);
				}
				if ((RTC2_VALUE->minutes-ventil2)>=minuty )
				{
					PORTD&=~(1<<PD6);
				}
				if ((RTC2_VALUE->minutes-ventil3)>=minuty )
				{
					PORTD&=~(1<<PD5);
				}
			}
			//----------------------ZAVLAHA se sekvenci---------------//
			else if (sekvence==true)
			{
				rtc2_update(RTC2_VALUE);
				if (hodiny==RTC2_VALUE->hours && minuty== RTC2_VALUE->minutes )//zapne se ventil 1
				{
					
					PORTD |=(1<<PD7);
				}
				if ((RTC2_VALUE->minutes-ventil1)>=minuty )//jakmile uplyne nastavena doba 1.ventilu zapne se ventil2
				{
					PORTD&=~(1<<PD7);
					PORTD |=(1<<PD6);
					minuty_sekv=ventil1+ventil2;
				}
				
				if ((RTC2_VALUE->minutes-minuty_sekv)>=minuty )//jakmile uplyne nastavena doba 2.ventilu zapne se ventil3
				{
					PORTD&=~(1<<PD6);
					PORTD |=(1<<PD5);
					minuty_sekv+=ventil3;
				}
				if ((RTC2_VALUE->minutes-minuty_sekv)>=minuty)//vypnut posledniho ventilu
				{
					PORTD&=~(1<<PD5);
				}
							
			}			
			
}
}